// pages/myCart/myCart.js
Page({

    /**
     * 页面的初始数据
     */
    data: {
        selected: false,
        selectButton: false,
        selectAllStatus: false,
        totalPrice: "0.00",
        list: [],
        num: 0, //选中的产品数量
        startX: 0,
        startY: 0

        // list: [{
        //         id: 1,
        //         pic: '../../imges/item-1.jpg',
        //         title: '标题一',
        //         subTitle: '副标题------------',
        //         price: "￥45.00",
        //         num: 1
        //     },
        //     {
        //         id: 2,
        //         pic: '../../imges/item-1.jpg',
        //         title: '标题二',
        //         subTitle: '副标题------------',
        //         price: "￥255.00",
        //         num: 2
        //     },
        // ],

    },

    /**
     * 生命周期函数--监听页面加载
     */


    onLoad: function (options) {
        this.getShop();
    },
    //  获取购物车数据
    //移动事件 获取刚开始触摸屏幕的坐标
    touchstart: function (e) {
        // console.log(e.changedTouches[0].clientX);
        this.setData({
            startX: e.changedTouches[0].clientX,
            startY: e.changedTouches[0].clientY
        })
    },
    touchmove: function (e) {
        // console.log(e);
        var index = e.currentTarget.dataset.index, //操作当前元素的index


            list = this.data.list, //操作元素的容器
            startX = this.data.startX,
            moveX = e.changedTouches[0].clientX
        if (moveX < startX) {
            //容器向左滑了
            list[index].isTouchMove = true
        } else {
            //向右划了
            list[index].isTouchMove = false
        }
        this.setData({
            list: list
        })
    },
    //  获取购物车数据
    getShop:function(){
        wx.request({
          url: 'http://iwenwiki.com:3002/api/cart/list',
          success:res=>{
            console.log(res.data);
            if(res.data.status==200){    
              var list = res.data.data.result;
              var num=0;
            
             //获取数据-------
             //判断全选按钮的状态 如果选中的状态 ok？ 所有的list选中
              var selectAllStatus=this.data.selectAllStatus;
              if (selectAllStatus){
                 for(var i=0;i<list.length;i++){
                   list[i].selected=true
                 } 
                
                num=list.length;
    
              }
              //渲染list
              this.setData({
                list:list,
                num:num
              })
              //价格
              this.totalPrice();
            }
          }
        })
      },
    //删除购物车里面的商品
    remove: function (e) {
        console.log(e);
        var id = e.currentTarget.dataset.id;
        wx.request({
            url: 'http://iwenwiki.com:3002/api/cart/delete',
            data: {
                id: id
            },
            success: res => {
                console.log(res.data);
                if (res.data.status == 200) {
                    wx.showToast({
                        title: '已从购物车删除',

                    });
                   this.getShop();
                }
            }
        })



    },

    //计算总价格
    totalPrice: function () {

        var list = this.data.list;
        var total = 0;

        for (var i = 0; i < list.length; i++) {
            if (list[i].selected) {
                total += list[i].price * list[i].num
            }
        }
        this.setData({
            totalPrice: total.toFixed(2)
        })

    },
    // 选贼需要购买的商品
    showIcon: function (e) {
        var list = this.data.list
        var index = e.currentTarget.dataset.index;
        var selected = list[index].selected;
        console.log(selected);
        var num = this.data.num
        list[index].selected = !selected
        if (list[index].selected) {
            num++;
        } else {
            num--;
        }
        this.setData({
            list: list,
            num: num,

        })
        console.log('选中个数' + num);
        //若购买商品数量大于0 则结算变高亮
        if (num > 0) {
            this.setData({
                selectButton: true
            })
        } else {
            this.setData({
                selectButton: false
            })
        }
        console.log(list.length);
        if (num === list.length) {
            this.setData({
                selectAllStatus: true
            })
        } else {
            this.setData({
                selectAllStatus: false
            })
        }

        this.totalPrice();
    },
    // 全选
    selectedAll: function () {
        var selectAllStatus = !this.data.selectAllStatus, //点击取反当前状态
            list = this.data.list,
            num = this.data.num,
            selectButton = this.data.selectButton

        // 控制所有list选中框
        for (var i = 0; i < list.length; i++) {
            list[i].selected = selectAllStatus
        }
        if (selectAllStatus) {
            num = list.length;
            selectButton = true;
        } else {
            num = 0;
            selectButton = false
        }
        //   更改数据
        this.setData({
            list: list,
            num: num,
            selectAllStatus: selectAllStatus,
            selectButton: selectButton
        });
        this.totalPrice()


    },

    // 修改购物城商品的数量 增加
    addShop: function (e) {
        var list = this.data.list
        var num = e.currentTarget.dataset.num,
            index = e.currentTarget.dataset.index;
        num++;
        if (num > 13) {
            wx.showToast({
                title: '此商品单次最多只能购买13件',
                icon: 'none'
            });
            return;
        }
        list[index].num = num;
        this.setData({
            list: list
        });

        wx.request({
            url: 'http://iwenwiki.com:3002/api/cart/update',
            data: {
                num: num,
                id: list[index].id
            },
            success: res => {
                if (res.data.status == 200) {
                    console.log(res.data);
                }
            },
            complete: result => {
                console.log(result);
            }
        })

        //   更改修改数量后的价格
        this.totalPrice()
    },
    // 修改购物城商品的数量 减少
    reduceShop: function (e) {
        var list = this.data.list,
            index = e.currentTarget.dataset.index,
            num = list[index].num;

        num--;
        if (num < 1) {
            wx.showToast({
                title: '购买数量最少为1',
                icon: 'none'
            });
            return;
        }
        list[index].num = num;
        this.setData({
            list: list
        });

        wx.request({
            url: 'http://iwenwiki.com:3002/api/cart/update',
            data: {
                num: num,
                id: list[index].id
            },
            success: res => {
                if (res.data.status == 200) {
                    console.log(res.data);
                }
            },
            complete: result => {
                console.log(result);
            }
        })

        //   更改修改数量后的价格
        this.totalPrice()
    },

    //支付
    balabce:function (e) {
        wx.redirectTo({
            url: '../complete/complete',
        })
        
    },


    //选择需要购买的商品
    // showIcon:function (e) {
    //     var list=this.data.list
    //     var index=e.currentTarget.dataset.index;
    //     var selected=this.dataa.selected;
    //     list[index].selected=!selected
    //     this.setData({
    //         list:list
    //     })
    // },



    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    // demo: function () {
    //     this.setData({
    //         isTouchMove: !this.data.isTouchMove
    //     })
    // },
    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        this.getShop();
     
        // //重新 打开购物城 重置
        // this.setData({
        //     selectAllStatus: false,
        //     totalPrice: "0.00",
        //     selectButton: false,
        //     num:0
        // })

       


    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})